<?php

if (!defined('FORUM_ROOT') )
	define('FORUM_ROOT', '../../../');

require FORUM_ROOT.'include/common.php';
require FORUM_ROOT.'extensions/pan_consultor/inc/functions.php';

$action = isset($_POST['action']) ? $_POST['action'] : null;
$errors = $operators_online = $online_info = array();

$query = array(
	'SELECT'	=> 'op.id, op.user_id, op.username, op.num_clients, op.status, op.email_notify_msg, op.welcome_msg, o.ident, o.logged, o.idle, o.prev_url',
	'FROM'		=> 'pan_consultor_operators AS op',
	'JOINS'		=> array(
		array(
			'INNER JOIN'	=> 'online AS o',
			'ON'			=> 'o.user_id=op.user_id',
		),
	),
	'WHERE'		=> 'o.idle=0',
	'ORDER BY'	=> 'o.logged DESC'
);
$result = $forum_db->query_build($query) or error(__FILE__, __LINE__);
while ($rows = $forum_db->fetch_assoc($result)) {
	$operators_online[] = $rows;
}

$query = array(
	'SELECT'	=> 'o.user_id, o.ident, o.logged, o.idle, o.prev_url',
	'FROM'		=> 'online AS o',
//	'WHERE'		=> 'o.user_id > 1'
);
$result = $forum_db->query_build($query) or error(__FILE__, __LINE__);
while ($online = $forum_db->fetch_assoc($result)) {
	$online_info[$online['user_id']] = $online;//['user_id']
}

if ($action == 'refresh')
{
	$json_array = array();
	$json_array['messages'] = array();
	$json_array['wellcome'] = $json_array['consaltor_info'] = $json_array['contacts'] = $json_array['sounds'] = '';
	$json_array['online'] = 0;
	$cur_ip = get_remote_address();
	
	$query = array(
		'SELECT'	=> 'p.id, p.user_id, p.message, p.posted, p.status, c.client_name, c.client_email',
		'FROM'		=> 'pan_consultor_posts AS p',
		'JOINS'		=> array(
			array(
				'INNER JOIN'	=> 'pan_consultor_clients AS c',
				'ON'			=> 'c.id=p.client_id'
			),
		),
		'WHERE'		=> 'c.client_ip=\''.$forum_db->escape($cur_ip).'\'',
//		'ORDER BY'	=> 'ch.posted ASC'
	);
	$result = $forum_db->query_build($query) or error(__FILE__, __LINE__);
	
	$posts_info = array();
	while ($rows = $forum_db->fetch_assoc($result)) {
		$posts_info[] = $rows;
		$client_info = array(
			'client_name' => $rows['client_name'],
			'client_email' => $rows['client_email'],
		);
	}
	
	$num_operatops_online = count($operators_online);
	
	if ($num_operatops_online == 0)
	{
		$json_array['consaltor_info'] = '
			<div class="offline">
				<div class="accost">
					<span>Сейчас операторы заняты. Напишите нам и мы обязательно вам ответим.</span>
				</div>
			</div>';
		
		if (empty($client_info['client_email']))
		{
//			$json_array['contacts'] = '
//					<span class="cl-email"><input id="cl_email" type="email" name="email" placeholder="Ваш Email"></span>
//					<span class="cl-name"><input id="cl_name" type="text" name="name" placeholder="Ваше Имя"></span>';
		}
	}
	else if ($num_operatops_online == 1)
	{
		foreach ($operators_online as $key => $operator_online)
		{
			$operator_online_username =  (!empty($operator_online['username']) ? forum_htmlencode($operator_online['username']) : 'Оператор-'.$operator_online['user_id']);
			
			$json_array['consaltor_info'] = '
			<div class="online">
				'.pan_consultor_get_avatar($operator_online['user_id']).'
				<div class="operator-info">
					<span class="name">'.$operator_online_username.'</span>
					<span class="pos">Консультант</span>
				</div>
			</div>';
			
			$wellcome_msg =  (!empty($operator_online['welcome_msg']) ? forum_htmlencode($operator_online['welcome_msg']) : 'Здравствуйте! Я могу вам чем-то помочь?');
			
			$json_array['wellcome'] = '<li>
					<div class="msg answer">
						<p>'.$wellcome_msg.'</p>
					</div>
				</li>';
		}
		$json_array['online'] = 1;
	}
	else if ($num_operatops_online > 1)
	{
		foreach ($operators_online as $key => $operator_online)
		{
			$operator_online_username =  (!empty($operator_online['username']) ? forum_htmlencode($operator_online['username']) : 'Оператор-'.$operator_online['user_id']);
			
			$json_array['consaltor_info'] = '
			<div class="online">
				'.pan_consultor_get_avatar($operator_online['user_id']).'
				<div class="operator-info">
					<span class="name">'.$operator_online_username.'</span>
					<span class="pos">Консультант</span>
				</div>
			</div>';
			
			$wellcome_msg =  (!empty($operator_online['welcome_msg']) ? forum_htmlencode($operator_online['welcome_msg']) : 'Здравствуйте! Я могу вам чем-то помочь?');
			
			$json_array['wellcome'] = '<li>
					<div class="msg answer">
						<p>'.$wellcome_msg.'</p>
					</div>
				</li>';

			break;
		}
		$json_array['online'] = 1;
	}
	
	foreach ($posts_info as $key => $post)
	{
		if ($post['user_id'] > 1) {
			$json_array['messages'][] = '<li>
			<div class="msg answer">
					<p>'.forum_htmlencode($post['message']).'</p>
				</div>
			</li>';
		} else {
			$json_array['messages'][] = '<li>
				<div class="msg question">
					<p>'.forum_htmlencode($post['message']).'</p>
				</div>
			</li>';
		}
	}
	
	echo json_encode(array(
		'op_msg' => $json_array['consaltor_info'],
		'wellcome' => $json_array['wellcome'],
		'msgs' => implode('', $json_array['messages']),
		'contacts' => $json_array['contacts'],
		'online' => $json_array['online'],
		'sounds' => $json_array['sounds'],
	));
}
else if ($action == 'sent_msg')
{
	$message = isset($_POST['msg']) ? $_POST['msg'] : '';
	$url_from = isset($_POST['url_from']) ? forum_htmlencode($_POST['url_from']) : '';
	$url_now = isset($_POST['url_now']) ? forum_htmlencode($_POST['url_now']) : '';
	
	$cur_ip = get_remote_address();
	$time_now = time();
	
	$json_array = array();
	$json_array['messages'] = array();
	$json_array['wellcome'] = $json_array['consaltor_info'] = $json_array['contacts'] = '';
	$json_array['online'] = 0;
/*
	$query = array(
		'UPDATE'	=> 'pan_consultor_clients',
		'SET'		=> 'last_visit='.time(),
		'WHERE'		=> 'client_ip=\''.$forum_db->escape($cur_ip).'\'',
	);
	if ($cl_email != '' || $cl_name != '') {
		if ($cl_email != '' && $cl_name != '') $query['SET'] .= ', client_email=\''.$forum_db->escape($cl_email).'\', client_name=\''.$forum_db->escape($cl_name).'\'';
		else if ($cl_email != '') $query['SET'] .= 'client_email=\''.$forum_db->escape($cl_email).'\'';
		else if ($cl_name != '') $query['SET'] .= 'client_name=\''.$forum_db->escape($cl_name).'\'';
	}
	$result = $forum_db->query_build($query) or error(__FILE__, __LINE__);
*/
	//
	if ($forum_user['id'] == '1' && $message != '')
	{
		$query = array(
			'SELECT'	=> 'c.id, c.client_ip',
			'FROM'		=> 'pan_consultor_clients AS c',
			'WHERE'		=> 'c.client_ip=\''.$forum_db->escape($cur_ip).'\'',
			'LIMIT'		=> '1',
		);
		$result = $forum_db->query_build($query) or error(__FILE__, __LINE__);
		$clients = $forum_db->fetch_assoc($result);
		$num_clients = count($clients['id']);
		
		if ($num_clients < 1)
		{
			//CREATE NEW client
			$query = array(
				'INSERT'	=> 'user_id, client_ip, entered, url_from',
				'INTO'		=> 'pan_consultor_clients',
				'VALUES'	=> ''.$forum_user['id'].', \''.$forum_db->escape($cur_ip).'\', '.$time_now.', \''.$forum_db->escape($url_from).'\'',
			);
			$forum_db->query_build($query) or error(__FILE__, __LINE__);
			$new_id = $forum_db->insert_id();
			
			//CREATE NEW POST
			$query = array(
				'INSERT'	=> 'user_id, message, posted, client_id',
				'INTO'		=> 'pan_consultor_posts',
				'VALUES'	=> ''.$forum_user['id'].', \''.$forum_db->escape($message).'\', '.time().', '.$new_id
			);
			$forum_db->query_build($query) or error(__FILE__, __LINE__);
		}
		else
		{
			//CREATE NEW POST
			$query = array(
				'INSERT'	=> 'user_id, message, posted, client_id',
				'INTO'		=> 'pan_consultor_posts',
				'VALUES'	=> ''.$forum_user['id'].', \''.$forum_db->escape($message).'\', '.time().', '.$clients['id']
			);
			$forum_db->query_build($query) or error(__FILE__, __LINE__);
		}
		
		$query = array(
			'UPDATE'	=> 'pan_consultor_clients',
			'SET'		=> 'num_posts=num_posts+1, last_visit='.$time_now.', url_now=\''.$forum_db->escape($url_now).'\'',
			'WHERE'		=> 'client_ip=\''.$forum_db->escape($cur_ip).'\''
		);
		$forum_db->query_build($query) or error(__FILE__, __LINE__);
	}
	
	$query = array(
		'SELECT'	=> 'p.id, p.user_id, p.message, p.posted, p.status, c.client_ip, c.client_name, c.client_email, c.mail_delivery',
		'FROM'		=> 'pan_consultor_posts AS p',
		'JOINS'		=> array(
			array(
				'INNER JOIN'	=> 'pan_consultor_clients AS c',
				'ON'			=> 'c.id=p.client_id'
			),
		),
		'WHERE'		=> 'c.client_ip=\''.$forum_db->escape($cur_ip).'\'',
//		'ORDER BY'	=> 'ch.posted ASC'
	);
	$result = $forum_db->query_build($query) or error(__FILE__, __LINE__);
	
	$posts_info = array();
	while ($rows = $forum_db->fetch_assoc($result)) {
		$posts_info[] = $rows;
		$client_info = array(
			'client_ip' => $rows['client_ip'],
			'client_name' => $rows['client_name'],
			'client_email' => $rows['client_email'],
			'mail_delivery' => $rows['mail_delivery'],
		);
	}
	
	$num_operatops_online = count($operators_online);
	
	if ($num_operatops_online == 0)
	{
		$json_array['consaltor_info'] = '
			<div class="offline">
				<div class="accost">
					<span>Сейчас операторы заняты. Напишите нам и мы обязательно вам ответим.</span>
				</div>
			</div>';
		
		if (empty($client_info['client_email']))
		{
//			$json_array['contacts'] = '
//					<span class="cl-email"><input id="cl_email" type="email" name="email" placeholder="Ваш Email"></span>
//					<span class="cl-name"><input id="cl_name" type="text" name="name" placeholder="Ваше Имя"></span>';
		}
		
		//Send notify on email
		if ($client_info['mail_delivery'] == 0)
		{
			pan_consultor_email_notify($message, $client_info);
			
			$query = array(
				'UPDATE'	=> 'pan_consultor_clients',
				'SET'		=> 'mail_delivery=1',
				'WHERE'		=> 'client_ip=\''.$forum_db->escape($cur_ip).'\''
			);
			$forum_db->query_build($query) or error(__FILE__, __LINE__);
		}
	}
	else if ($num_operatops_online == 1)
	{
		foreach ($operators_online as $key => $operator_online)
		{
			$operator_online_username =  (!empty($operator_online['username']) ? forum_htmlencode($operator_online['username']) : 'Оператор-'.$operator_online['user_id']);
			
			$json_array['consaltor_info'] = '
			<div class="online">
				'.pan_consultor_get_avatar($operator_online['user_id']).'
				<div class="operator-info">
					<span class="name">'.$operator_online_username.'</span>
					<span class="pos">Консультант</span>
				</div>
			</div>';
			
			$wellcome_msg =  (!empty($operator_online['welcome_msg']) ? forum_htmlencode($operator_online['welcome_msg']) : 'Здравствуйте! Я могу вам чем-то помочь?');
			
			$json_array['wellcome'] = '<li>
					<div class="msg answer">
						<p>'.$wellcome_msg.'</p>
					</div>
				</li>';
		}
		$json_array['online'] = 1;
	}
	else if ($num_operatops_online > 1)
	{
		foreach ($operators_online as $key => $operator_online)
		{
			$operator_online_username =  (!empty($operator_online['username']) ? forum_htmlencode($operator_online['username']) : 'Оператор-'.$operator_online['user_id']);
			
			$json_array['consaltor_info'] = '
			<div class="online">
				'.pan_consultor_get_avatar($operator_online['user_id']).'
				<div class="operator-info">
					<span class="name">'.$operator_online_username.'</span>
					<span class="pos">Консультант</span>
				</div>
			</div>';
			
			$wellcome_msg =  (!empty($operator_online['welcome_msg']) ? forum_htmlencode($operator_online['welcome_msg']) : 'Здравствуйте! Я могу вам чем-то помочь?');
			
			$json_array['wellcome'] = '<li>
					<div class="msg answer">
						<p>'.$wellcome_msg.'</p>
					</div>
				</li>';
			break;
		}
		$json_array['online'] = 1;
	}
	
	
	foreach ($posts_info as $key => $post)
	{
		if ($post['user_id'] > 1) {
			$json_array['messages'][] = '<li>
			<div class="msg answer">
					<p>'.forum_htmlencode($post['message']).'</p>
				</div>
			</li>';
		} else {
			$json_array['messages'][] = '<li>
				<div class="msg question">
					<p>'.forum_htmlencode($post['message']).'</p>
				</div>
			</li>';
		}
	}
	
	echo json_encode(array(
		'op_msg' => $json_array['consaltor_info'],
		'wellcome' => $json_array['wellcome'],
		'msgs' => implode('', $json_array['messages']),
		'contacts' => $json_array['contacts'],
		'online' => $json_array['online'],
	));
	
}
else if ($action == 'type_text')
{
	$message = isset($_POST['msg']) ? $_POST['msg'] : null;
	if (!empty($message))
	{
		if (count($operators_online) < 1)
		{
//			pan_consultor_email_notify($message);
			
		}
	}
	
}

// End the transaction
$forum_db->end_transaction();
// Close the db connection (and free up any result data)
$forum_db->close();
