<?php

if (!defined('FORUM_ROOT') )
	define('FORUM_ROOT', '../../../');

require FORUM_ROOT.'include/common.php';
require FORUM_ROOT.'extensions/pan_consultor/inc/functions.php';

$action = isset($_POST['action']) ? $_POST['action'] : null;
$errors = array();

if ($action == 'clients_list')
{
	$unread_msg = isset($_POST['unread']) ? $_POST['unread'] : 0;
	$json_array = array();
	$json_array['clients'] = $json_array['errors'] = array();
	$json_array['sound'] = $json_array['reminder'] = '';
	
	$query = array(
		'SELECT'	=> 'c.id, c.client_ip, c.client_name, c.client_email, c.location, c.url_from, c.url_now, c.num_posts, c.last_visit, c.operator_id, c.first_visit',
		'FROM'		=> 'pan_consultor_clients AS c',
		'ORDER BY'	=> 'c.last_visit DESC'
	);
	$result = $forum_db->query_build($query) or error(__FILE__, __LINE__);
	
	$clients_info = array();
	while ($rows = $forum_db->fetch_assoc($result)) {
		$clients_info[$rows['id']] = $rows;
	}
	
	$query = array(
		'SELECT'	=> 'p.id, p.user_id, p.message, p.posted, p.status, p.client_id',
		'FROM'		=> 'pan_consultor_posts AS p',
		'WHERE'		=> 'p.status=\'sent\'',
//		'LIMIT'		=> '30',
	);
	$result = $forum_db->query_build($query) or error(__FILE__, __LINE__);
	
	$posts_info = array();
	while ($rows = $forum_db->fetch_assoc($result)) {
		if (!isset($posts_info[$rows['client_id']])) {
			$posts_info[$rows['client_id']] = 1;
		} else {
			$posts_info[$rows['client_id']]++;
		}
	}
	
	$num_unread = $num_first_visit = 0;
	$clients_first_visit = array();
	foreach ($clients_info as $id => $client)
	{
		$client_name = (!empty($client['client_name']) ? $client['client_name'] : 'Клиент-'.$client['id']);
		
		if ($client['first_visit'] == 1) {
			$clients_first_visit[] = $client['id'];
			$num_first_visit++;
		}
		
		$class_first_visit = ($client['first_visit'] == 1) ? 'first-visit' : '';
		
		if (isset($pan_consultor_online[$client['client_ip']]) && $pan_consultor_online[$client['client_ip']]['idle'] == 0)
			$this_client = '<span class="client online '.$class_first_visit.'"><a href="'.forum_link($forum_url['pan_consultor_dialog'], $client['id']).'">'.forum_htmlencode($client_name).'</a></span>';
		else
			$this_client = '<span class="client offline"><a href="'.forum_link($forum_url['pan_consultor_dialog'], $client['id']).'">'.forum_htmlencode($client_name).'</a></span>';
		
		$get_num_unread = isset($posts_info[$id]) ? $posts_info[$id] : 0;
		$show_num_unread = $get_num_unread > 0 ? '<span style="color:red;font-weight:bold;">'.$get_num_unread.'</span>' : $get_num_unread;
		$client_num_posts = $client['num_posts'].'/'.$show_num_unread;
		
		$json_array['clients'][] = '<tr><td class="tc0">'.$this_client.'</td>
			<td class="tc0">'.parse_url($client['url_from'], PHP_URL_HOST).'</td>
			<td class="tc0"><a href="'.$client['url_now'].'" target="_blank">'.parse_url($client['url_now'], PHP_URL_PATH).'</a></td>
			<td class="tc0">'.forum_htmlencode($client['client_ip']).'</td>
			<td class="tc0">'.format_time($client['last_visit']).'</td>
			<td class="tc0">'.$client_num_posts.'</td></tr>';
			
		$num_unread = $num_unread + $get_num_unread;
	}
	
	if (count($json_array['clients']) < 1)
		$json_array['errors'][] = '<p class="warn">В данный момент на форуме нет активных клиентов.</p>';
	
	if ($num_unread > $unread_msg)
		$json_array['sound'] = '<audio autoplay>
				<source src="'.$forum_url['pan_consultor_url'].'/sound/inbox_msg.wav" type="audio/wav">
				<source src="'.$forum_url['pan_consultor_url'].'/sound/inbox_msg.ogg" type="audio/ogg">
				<source src="'.$forum_url['pan_consultor_url'].'/sound/inbox_msg.mp3" type="audio/mpeg">
			</audio>';
	else if ($num_unread > 0)
		$json_array['sound'] = '<audio autoplay>
				<source src="'.$forum_url['pan_consultor_url'].'/sound/notify.wav" type="audio/wav">
				<source src="'.$forum_url['pan_consultor_url'].'/sound/notify.ogg" type="audio/ogg">
				<source src="'.$forum_url['pan_consultor_url'].'/sound/notify.mp3" type="audio/mpeg">
			</audio>';
	else if ($num_first_visit > 0)
		$json_array['sound'] = '<audio autoplay>
				<source src="'.$forum_url['pan_consultor_url'].'/sound/online.wav" type="audio/wav">
				<source src="'.$forum_url['pan_consultor_url'].'/sound/online.ogg" type="audio/ogg">
				<source src="'.$forum_url['pan_consultor_url'].'/sound/online.mp3" type="audio/mpeg">
			</audio>';
	//Клиент ... покинул форум
	
	
	echo json_encode(array(
		'clients'		=> implode("\n", $json_array['clients']),
		'sound'			=> $json_array['sound'],
		'reminder'		=> $json_array['reminder'],
		'num_unread'	=> $num_unread,
		'errors'		=> (count($json_array['errors']) > 0) ? '<div class="ct-box warn-box">'.implode("\n", $json_array['errors']).'</div>' : '',
	));
	
	
	if (count($clients_first_visit) > 0)
	{
		$query = array(
			'UPDATE'	=> 'pan_consultor_clients',
			'SET'		=> 'first_visit=0',
			'WHERE'		=> 'id IN ('.implode(',', $clients_first_visit).')'
		);
		$forum_db->query_build($query) or error(__FILE__, __LINE__);
	}
	
}
else if ($action == 'dialog')
{
	$cid = $_POST['cid'];
	$json_array = array();
	$json_array['msgs'] = array();
	
	$query = array(
		'SELECT'	=> 'p.id, p.user_id, p.message, p.posted, p.status, p.client_id, c.last_visit, c.operator_id',
		'FROM'		=> 'pan_consultor_posts AS p',
		'JOINS'		=> array(
			array(
				'INNER JOIN'	=> 'pan_consultor_clients AS c',
				'ON'			=> 'c.id=p.client_id'
			),
		),
		'WHERE'		=> 'p.client_id='.$cid, 
		'ORDER BY'	=> 'p.posted DESC'
	);
	$result = $forum_db->query_build($query) or error(__FILE__, __LINE__);
	
	$posts_info = array();
	while ($post = $forum_db->fetch_assoc($result))
	{
		if ($post['user_id'] > 1)
		{
			$json_array['msgs'][] = '<li>
				<div class="msg answer">
					<p>'.forum_htmlencode($post['message']).'</p>
				</div>
			</li>';
		}
		else
		{
			$json_array['msgs'][] = '<li>
				<div class="msg question">
					<p>'.forum_htmlencode($post['message']).'</p>
				</div>
			</li>';
		}
	}
	
	echo json_encode(array(
		'msgs'		=> implode("\n", $json_array['msgs']),
	));
	
}

// End the transaction
$forum_db->end_transaction();
// Close the db connection (and free up any result data)
$forum_db->close();
