<?php

function pan_consultor_get_avatar($uid=0)
{
	global $forum_db, $base_url, $forum_config;
	
	if ($uid > 0)
	{
		$query = array(
			'SELECT'	=> 'u.id, u.avatar',
			'FROM'		=> 'users AS u',
			'WHERE'		=> 'u.id='.$uid,
		);
		$result = $forum_db->query_build($query) or error(__FILE__, __LINE__);
		$user_info = $forum_db->fetch_assoc($result);
	
		switch ($user_info['avatar'])
		{
			case FORUM_AVATAR_GIF:
				$avatar_filename = $user_info['id'].'.gif';
				break;
			case FORUM_AVATAR_JPG:
				$avatar_filename = $user_info['id'].'.jpg';
				break;
			case FORUM_AVATAR_PNG:
				$avatar_filename = $user_info['id'].'.png';
				break;
			case FORUM_AVATAR_NONE:
				$noavatar = TRUE;
				break;
			default:
				$noavatar = TRUE;
				break;
		}
	
		if(!isset($noavatar))
			$user_avatar = '<img src="'.$base_url.'/'.$forum_config['o_avatars_dir'].'/'.$avatar_filename.'" />';
		else
			$user_avatar = '<img src="'.$base_url.'/extensions/pan_consultor/style/default_avatar.png"/>';
		return $user_avatar;
	}
}


function pan_consultor_email_notify($message, $client_info)
{
	global $forum_db, $forum_url, $forum_user, $forum_config, $lang_common;

	$client_ident = !empty($client_info['client_name']) ? forum_htmlencode($client_info['client_name']) : $client_info['client_ip'];

	$query = array(
		'SELECT'	=> 'op.id, op.user_id, op.username, op.num_clients, op.status, op.email_notify_msg, op.welcome_msg, u.email, u.language, u.last_visit',
		'FROM'		=> 'pan_consultor_operators AS op',
		'JOINS'		=> array(
			array(
				'INNER JOIN'	=> 'users AS u',
				'ON'			=> 'u.id=op.user_id',
			),
		),
		'WHERE'		=> 'op.email_notify_msg=1',
		'ORDER BY'	=> 'u.last_visit DESC'
	);
	$result = $forum_db->query_build($query) or error(__FILE__, __LINE__);
	
	while ($operator = $forum_db->fetch_assoc($result))
	{
		if (file_exists($forum_url['pan_consultor_path'].'/lang/'.$operator['language'].'/mail_template/notifications.tpl'))
			$mail_tpl = forum_trim(file_get_contents($forum_url['pan_consultor_path'].'/lang/'.$operator['language'].'/mail_template/notifications.tpl'));
		else
			$mail_tpl = forum_trim(file_get_contents($forum_url['pan_consultor_path'].'/lang/English/mail_template/notifications.tpl'));
		
		// The first row contains the subject
		$first_crlf = strpos($mail_tpl, "\n");
		$mail_subject = forum_trim(substr($mail_tpl, 8, $first_crlf-8));
		$mail_message = forum_trim(substr($mail_tpl, $first_crlf));
		
		//BODY of MAIL
		$mail_subject = str_replace('<client_ident>', $client_ident, $mail_subject);
		$mail_message = str_replace('<client_ident>', $client_ident, $mail_message);
		$mail_message = str_replace('<client_message>', $message, $mail_message);
		$mail_message = str_replace('<clients_url>', forum_link($forum_url['pan_consultor_clients']), $mail_message);
		$mail_message = str_replace('<board_mailer>', sprintf($lang_common['Forum mailer'], $forum_config['o_board_title']), $mail_message);

		if (!defined('FORUM_EMAIL_FUNCTIONS_LOADED'))
			include FORUM_ROOT.'include/email.php';

		forum_mail(forum_htmlencode($operator['email']), $mail_subject, $mail_message);
	}
}



/*
function get_avatar( $list_users )
{
	global $base_url, $forum_config;
	
	switch ($list_users['avatar'])
	{
		case FORUM_AVATAR_GIF:
			$avatar_filename = $list_users['id'].'.gif';
			break;
		case FORUM_AVATAR_JPG:
			$avatar_filename = $list_users['id'].'.jpg';
			break;
		case FORUM_AVATAR_PNG:
			$avatar_filename = $list_users['id'].'.png';
			break;
		case FORUM_AVATAR_NONE:
			$noavatar = TRUE;
			break;
		default:
			$noavatar = TRUE;
			break;
	}
	
	if(!isset($noavatar))
		$user_avatar = '<img src="'.$base_url.'/'.$forum_config['o_avatars_dir'].'/'.$avatar_filename.'" />';
	else
		$user_avatar = '<img src="'.$base_url.'/extensions/pan_private_chat/style/default_avatar.png"/>';
	return $user_avatar;
}

function pan_private_chat_get_unread_msg()
{
	global $forum_db;
	
	$unread_messages = array();
	$query = array(
		'SELECT'	=> 'sender_id, receiver_id',
		'FROM'		=> 'pan_private_chat',
		'WHERE'		=> 'status=\'sent\''
	);
	$result = $forum_db->query_build($query) or error(__FILE__, __LINE__);
	
	while ($chat_info = $forum_db->fetch_assoc($result) )
	{
		if (!isset($unread_messages[$chat_info['receiver_id']]) )
		{
			$unread_messages[$chat_info['receiver_id']] = array(
				$chat_info['sender_id'] => 1,
			);
			
		} else {
			
			if (!isset($unread_messages[$chat_info['receiver_id']][$chat_info['sender_id']]) )
			{
				$unread_messages[$chat_info['receiver_id']][$chat_info['sender_id']] = 1;
				
			} else {
				
				$unread_messages[$chat_info['receiver_id']][$chat_info['sender_id']] = $unread_messages[$chat_info['receiver_id']][$chat_info['sender_id']]+1;
			}
		}
	}

	return $unread_messages;
}

function pan_chat_gen_cache_chars($receiver_id, $chars)
{
	global $forum_url, $forum_user, $online_info, $pan_chat_temp;

	$now = time();
	$gen_cache = false;
	$output = array();

	//если значение существует
	if (isset($pan_chat_temp[$forum_user['id']]['receiver']) && ($pan_chat_temp[$forum_user['id']]['receiver'] == $receiver_id) )
	{

		if ($chars > 0)
		{
			$output = array(
				$forum_user['id'] => array(
					'receiver'	=> $receiver_id,
					'time'		=> $now,
					'chars'		=> $chars
			));
			
			foreach ($pan_chat_temp as $key => $val)
			{
				if ($key != $forum_user['id'] && isset($online_info[$key]) && ($val['time']+20) > $now)
					$output[$key] = $val;
			}
			
			$gen_cache = true;

		}
		else
		{
			foreach ($pan_chat_temp as $key => $val)
			{
				if ($key != $forum_user['id'] && isset($online_info[$key]) && ($val['time']+20) > $now)
					$output[$key] = $val;
			}
			
			$gen_cache = true;
			
		}
	
	}
	//если значения не существует, но юзер печатает
	else if ($chars > 0)
	{
		$output = array(
			$forum_user['id'] => array(
				'receiver'	=> $receiver_id,
				'time'		=> $now,
				'chars'		=> $chars
		));
		
		if (isset($pan_chat_temp) && !empty($pan_chat_temp) )
		{
			foreach ($pan_chat_temp as $key => $val)
			{
				if (isset($online_info[$key]) && ($val['time']+20) > $now)
					$output[$key] = $val;
			}
		}
		
		$gen_cache = true;
	
	} else {
		
		if (isset($pan_chat_temp) && !empty($pan_chat_temp) )
		{
			foreach ($pan_chat_temp as $key => $val)
			{
				if (isset($online_info[$key]) && ($val['time']+20) > $now)
					$output[$key] = $val;
			}
		}
		
		$gen_cache = true;
		
	}

	if ($gen_cache === true)
	{
		$fh = @fopen($forum_url['pan_private_chat_path'].'/cache/typing.php', 'wb');
		if (!$fh)
			error('Unable to write censor cache file to cache directory. Please make sure PHP has write access to the directory \'cache\'.', __FILE__, __LINE__);

		fwrite($fh, '<?php'."\n\n".'$pan_chat_temp = '.var_export($output, true).';'."\n\n".'?>');
		fclose($fh);
	}
	
}


function pan_chat_get_uploaded_imgs($folder, &$all_files)
{
	$fp = opendir ( $folder );
	
	while ( $cv_file = readdir ( $fp ) ) 
	{
		if ( is_file( $folder."/".$cv_file ) )
		{
			$all_files[] = $cv_file;
		} elseif ( $cv_file != "." && $cv_file != ".." && is_dir ( $folder."/".$cv_file ) ) {
			uploads_list_files( $folder."/".$cv_file, $all_files );
		}
	}
	closedir($fp);
}


function pan_chat_clear_images($all_files)
{
	global $forum_db, $forum_url;

	$patern = '/(https?:\/\/)?(www\.)?([-а-яa-zёЁцушщхъфырэчстью0-9_\.]{2,}\.)(рф|[a-z]{2,6})((\/[-а-яёЁцушщхъфырэчстьюa-z0-9_]{1,})?\/?([a-z0-9_-]{2,}\.[a-z]{2,6})?(\?[a-z0-9_]{2,}=[-0-9]{1,})?((\&[a-z0-9_]{2,}=[-0-9]{1,}){1,})?)/i';

	$query = array(
		'SELECT'	=> 'message',
		'FROM'		=> 'pan_private_chat',
	);
	$result = $forum_db->query_build($query) or error(__FILE__, __LINE__);
	
	$imgs_in_msgs = array();
	while ($img_info = $forum_db->fetch_assoc($result) )
	{
		$message = parse_message($img_info['message'], 0);
		preg_match_all($patern, $message, $matches);
		
		for ($i = 0; $i < count($matches); $i++) {
			if (!empty($matches[0][$i]))
				$imgs_in_msgs[] = $matches[0][$i];
		}
	}
	
	foreach ($all_files as $file_name)
	{
		
		if (!in_array($file_name, $imgs_in_msgs) )
		{
			if (file_exists($forum_url['pan_private_chat_path'] .'/cache/images/'.$file_name) )
				unlink($forum_url['pan_private_chat_path'] .'/cache/images/'.$file_name);
			
//			echo 'Я удалил '.$file_name;
		}
	}
}

function pan_chat_sort_online($list_chats, $online_info)
{
	$output = array();
	
	foreach ($online_info as $id => $online)
	{
		if (isset($list_chats[$id]) && $online['idle'] == '0')
		{
			$output[$id] = $list_chats[$id];
		}
	}
	
	foreach ($online_info as $id => $online)
	{
		if (isset($list_chats[$id]) && $online['idle'] == '1')
		{
			$output[$id] = $list_chats[$id];
		}
	}
	
	foreach ($list_chats as $id => $chat_info)
	{
		if (!isset($online_info[$id]) )
		{
			$output[$id] = $chat_info;
		}
	}
	return $output;
}

function pan_chat_gen_cache_update_online($online_info)
{
	global $forum_url;
	
	$output = array('last_update' => time() );
	foreach ($online_info as $key => $val)
	{
		if ($key > 1)
		{
			$output[$key] = array(
				'uid'		=> $key,
				'idle'		=> isset($online_info[$key]['idle']) ? $online_info[$key]['idle'] : 1,
				'logged'	=> isset($online_info[$key]['logged']) ? $online_info[$key]['logged'] : 0,
			);
		}
	}

	$fh = @fopen($forum_url['pan_private_chat_path'].'/cache/update_online.php', 'wb');
	if (!$fh)
		error('Unable to write censor cache file to cache directory. Please make sure PHP has write access to the directory \'cache\'.', __FILE__, __LINE__);

	fwrite($fh, '<?php'."\n\n".'$pan_chat_update_online = '.var_export($output, true).';'."\n\n".'?>');
	fclose($fh);

}

function pan_chat_gen_cache_new_msg($unread_messages)
{
	global $forum_url;

//	$output = array('last_update' => time() );
	foreach ($unread_messages as $key => $val)
	{
		$output[$key] = $val;
	}
	
	$fh = @fopen($forum_url['pan_private_chat_path'].'/cache/new_msg.php', 'wb');
	if (!$fh)
		error('Unable to write censor cache file to cache directory. Please make sure PHP has write access to the directory \'cache\'.', __FILE__, __LINE__);

	fwrite($fh, '<?php'."\n\n".'$pan_chat_new_msg = '.var_export($output, true).';'."\n\n".'?>');
	fclose($fh);

}
*/

